
; ULW_case (about UpdateLayeredWindow)
; v.2008-05-05
; by kero

.386
.model flat,stdcall
option casemap: none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32

.const
  id    equ 100
.data
  _min   db "min",0
  _max   db "MAX",0
  _ulw   db "R          drag'n'drop",0
  _clc   db "click",0
  alpha  dd 128 ; (0<=alpha<=255)
  ulw    dd ULW_COLORKEY OR ULW_ALPHA ; ULW_OPAQUE ; 
  hinst  dd 0
  rect   RECT <40,40,100,100>
.data?
.code

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local rt:RECT, bfs:BLENDFUNCTION

  .if uMsg==WM_CLOSE
    invoke EndDialog,hWnd,0
    
  .elseif uMsg==WM_INITDIALOG
    invoke SetWindowText,hWnd,addr _min
    invoke GetSystemMetrics,SM_CYSCREEN
    shr eax,1
    mov rt.right,eax
    mov rt.bottom,eax
    xor ecx,ecx
    mov rt.left,ecx
    mov rt.top,ecx
    invoke SetWindowPos,hWnd,HWND_TOPMOST,ecx,ecx,eax,eax,SWP_FRAMECHANGED
    invoke GetWindowDC,hWnd
    mov ebx,eax
    invoke CreateCompatibleDC,ebx
    mov edi,eax
    invoke LoadImage,hinst,id,IMAGE_BITMAP,rt.right,rt.bottom,LR_DEFAULTCOLOR
    invoke SelectObject,edi,eax
    mov esi,eax
    invoke GetStockObject,BLACK_BRUSH
    invoke FillRect,edi,addr rect,eax
    invoke OffsetRect,addr rect,-60,-60
    invoke GetStockObject,WHITE_BRUSH
    invoke FrameRect,edi,addr rect,eax
    invoke SetTextColor,edi,White
    invoke SetBkMode,edi,TRANSPARENT
    invoke lstrlen,offset _ulw
    invoke TextOut,edi,4,4,offset _ulw,eax
    invoke lstrlen,offset _clc    
    invoke TextOut,edi,4,20,offset _clc,eax
    invoke BitBlt,ebx,0,0,rt.bottom,rt.bottom,edi,0,0,SRCCOPY
    mov bfs.BlendOp,AC_SRC_OVER
    mov bfs.BlendFlags,0
    mov eax,alpha
    mov bfs.SourceConstantAlpha,al
    mov bfs.AlphaFormat,AC_SRC_OVER ; (AC_SRC_OVER instead of AC_SRC_ALPHA)
    invoke UpdateLayeredWindow,hWnd,ebx,0,addr rt+8,edi,addr rt,Black,addr bfs,ulw
    invoke SelectObject,edi,esi
    invoke DeleteObject,eax
    invoke DeleteDC,edi
    invoke ReleaseDC,hWnd,ebx
    invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,40,40,SWP_FRAMECHANGED

  .elseif uMsg==WM_ERASEBKGND ; (contra murderous PrintWindow)

  .elseif uMsg==WM_STYLECHANGING ; (contra WS_EX_COMPOSITED & pro WS_EX_LAYERED)
    mov eax,wParam
    and eax,GWL_EXSTYLE
    .if eax!=0
      mov eax,lParam
      mov ecx,dword ptr[eax+4]
      or ecx,WS_EX_LAYERED
      and ecx,not WS_EX_COMPOSITED
      mov dword ptr[eax+4],ecx
    .endif
    
  .elseif uMsg==WM_RBUTTONUP
    invoke GetWindowRect,hWnd,addr rt
    mov ebx,rt.bottom
    sub ebx,rt.top
    .if ebx >40
      mov ebx,40
      mov eax,offset _min
    .else
      invoke GetSystemMetrics,SM_CYSCREEN
      mov ebx,eax
      shr ebx,1
      mov eax,offset _max
    .endif
    invoke SetWindowText,hWnd,eax
    invoke SetWindowPos,hWnd,0,0,0,ebx,ebx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
    invoke GetDesktopWindow                  ; (for FrameRector !)
    invoke GetWindow,eax,GW_CHILD
    invoke GetWindow,eax,GW_HWNDLAST
    invoke GetWindow,eax,GW_CHILD
    invoke GetWindow,eax,GW_CHILD
    mov ecx,eax
    invoke InvalidateRect,ecx,addr rt,1

  .elseif uMsg==WM_LBUTTONDBLCLK
    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    and eax,WS_EX_TOPMOST
    .if eax==0
      mov eax,HWND_TOPMOST
    .else
      mov eax,HWND_BOTTOM
    .endif
    invoke SetWindowPos,hWnd,eax,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_FRAMECHANGED

  .elseif uMsg==WM_LBUTTONDOWN
    invoke DefWindowProc,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0
  .else
    mov eax,FALSE
    ret
  .endif
  mov eax,TRUE
  ret
DlgProc endp

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,id,0,addr DlgProc,0
  invoke ExitProcess,eax
end start
